<!DOCTYPE html>
<html lang="en">
    <head>
        <title>Radix Sort Experiment</title>
        <meta name="viewport" content="width=device-width,height=device-height,initial-scale=1.0" />
        <meta charset="utf-8" />
        <style>
         .exp {
             display: none;
         }
         
         table {
             font-family: arial, sans-serif;
             border-collapse: collapse;
             width: 100%;
             text-align: center;
         }

         th {
             background-color: #2780C6;
             text-align: center;
             color: #fff;
         }

         #headings {
             background-color: #2780C6;
             text-align: center;
             color: #fff;
         }

         td {
             border: 1px solid #dddddd;
             padding: 8px;
             text-align: center;
             height: 20px;
         }

         tr:hover {
             background-color: #ddd;
         }

         .buckets {
             padding-left: 20vw;
         }
        </style>
        <!-- Google Tag Manager -->
        <script class="gtm">
          window.dataLayer = window.dataLayer || [];
          
          window.dataLayer.push ({
          'labName': 'Data Structures – 2',
          'discipline': 'Computer Science and Engineering',
          'college': 'IIITH',
          'phase': '3',
          'expName': 'Radix Sort',
          'expShortName': 'radix-sort'
          });


          (function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
          new Date().getTime(),event:'gtm.js'});var
          f=d.getElementsByTagName(s)[0],
          j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
          'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
          })(window,document,'script','dataLayer','GTM-W59SWTR');
        </script>
        <!-- End Google Tag Manager -->
    </head>
    <body>
        <!-- Google Tag Manager (noscript) -->
        <noscript class="gtm">
          <iframe height="0" width="0"
            src="https://www.googletagmanager.com/ns.html?id=GTM-W59SWTR"
            style="display:none;visibility:hidden">
          </iframe>
        </noscript>
        <!-- End Google Tag Manager (noscript) -->

        <div class="exp" title="Radixsort">

            <div class="longt">
                <h1 class="hlongt"> Introduction to Radix Sort</h1>
            </div>

            <div class="preamble">
                <div class="art txt" title="Estimation">
                    <div class="longt">
                        <h2 class="hlongt">Estimated Time</h2>
                    </div>
                    <div class="art-body">
                        <p>1 hour</p>
                    </div>
                </div>

                <div class="art req" title="Radixsort Introduction">
                    <div class="longt">
                        <h2 class="hlongt">Radixsort Introduction</h2>
                    </div>
                    <div class="description">
                        <p>Introduction video</p>
                    </div>
                </div>

                <div class="art txt" title="Prerequisites">
                    <div class="longt">
                        <h2 class="hlongt">Prerequisites of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <p>
                            This experiment requires you to have basic knowledge about :
                        </p>
                        <ul>
                            <li><a href="https://en.wikipedia.org/wiki/Sorting_algorithm">The Notion of Sorting</a></li>
                            <li><a href="https://en.wikipedia.org/wiki/Time_complexity">Time Complexity</a></li>
                            <li><a href="https://en.wikipedia.org/wiki/Space_complexity">Space Complexity</a></li>
                            <li><a href="https://en.wikipedia.org/wiki/Logarithm">Basics of Logarithm</a></li>
                        </ul>
                        <p>And above all, a curiosity to learn and explore!</p>
                    </div>
                </div>

                <div class="art txt" title="Overview">
                    <div class="longt">
                        <h2 class="hlongt">Overview of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <ul>
                            <li>
                                The aim of this experiment is to understand the Radix Sort algorithm,
                                its time and space complexity, and how it compares against other sorting algorithms.
                            </li>
                            <li>
                                The experiment features a series of
                                modules with video lectures, interactive demonstrations, simulations,
                                hands-on practice exercises and quizzes for self analysis.
                            </li>
                        </ul>
                    </div>
                </div>

                <div class="art txt" title="Learning Objectives">
                    <div class="longt">
                        <h2 class="hlongt">Learning Objectives of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <p>In this experiment, you will be able to do the following:</p><br>
                        <ul>
                            <li>Given an unsorted array of
                                numbers, generate a sorted array
                                of numbers by applying Radix Sort</li>
                            <li>Understand RadixSort, the
                                conditions under which it is
                                preferred over other
                                algorithms and the
                                associated time and space
                                complexity through
                                interactive animations.
                            </li>
                            <li>Compare Radix Sort with
                                other sorting algorithms and
                                realise it as a stable,
                                non-comparison based sorting
                                algorithm.
                            </li>
                        </ul>
                    </div>
                </div>

                <div class="art txt" title="Modules and Weightage">
                    <div class="longt">
                        <h2 class="hlongt">Experiment Modules & their Weightage</h2>
                    </div>
                    <div class="art-body">
                        <table>
                            <thead>
                                <tr>
                                    <th style="text-align:center">Module</th>
                                    <th style="text-align:center">Weightage</th>
                                    <th style="text-align:center">Expectation</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>Pre-Test</td>
                                    <td>20%</td>
                                    <td>Solve All Questions</td>
                                </tr>
                                <tr>
                                    <td>Radix sort</td>
                                    <td>50%</td>
                                    <td>Understand and Practice the full algorithm</td>
                                </tr>
                                <tr>
                                    <td>Post-test</td>
                                    <td>30%</td>
                                    <td>Solve all Questions</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>

            <div class="lu" title="Pre-Test">
                <div class="longt">
                    <h1 class="hlongt">Pre-Test of the Experiment</h1>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>

                    <div class="art txt" title="Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Instructions for Pre-Test</h2>
                        </div>
                        <div class="art-body">
                            <ul>
                                <li>Pretest includes questions on
                                    <strong>Sorting, Time and Space Complexity, Logarithms</strong></li>
                                <li>If you want to revise these topics
                                    before taking the quiz, go through the Recap module first.</li>
                                <li>Read the questions in
                                    the quiz section and select the
                                    correct option from the ones
                                    provided. Please note that some
                                    <strong>questions may
                                    have more than one
                                    correct response.</strong>
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>

                <div class="task" title="Recap">
                    <div class="longt">
                        <h2 class="hlongt">Quick look at Sorting, Time and Space Complexity, Logarithms</h2>
                    </div>

                    <div class="art txt" title="Sorting">
                        <div class="longt">
                            <h2 class="hlongt">What is Sorting?</h2>
                        </div>
                        <div class="art-body">
                            <p>Given a list of random
                               numbers, sorting means
                               <b>ordering</b> the numbers
                               in either ascending or
                               descending order.  By
                               default, we sort numbers in
                               an ascending order.
                            </p>
                        </div>
                    </div>

                    <div class="art req" title="Picture: Sorting">
                        <div class="longt">
                            <h2 class="hlongt">Unsorted and Sorted arrays</h2>
                        </div>
                        <div class="description">
                            <img src="./img/sort.png" alt="sort">
                        </div>
                    </div>

                    <div class="art txt" title="Time and Space Complexity">
                        <div class="longt">
                            <h2 class="hlongt">Time and Space Complexity</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                Time complexity of an
                                algorithm gives the measure
                                of time taken by it to run
                                as a function of the length
                                of the input.<br>Similarly,
                                Space complexity of an
                                algorithm quantifies the
                                amount of space or memory
                                taken by an algorithm to run
                                as a function of the length
                                of the input. <br>
                                Recall that suppose our
                                input is an array of N
                                elements, and our algorithm
                                iterates through the array
                                once, time complexity will
                                be O(N). If I run two
                                embedded loops to traverse
                                the array N times, time
                                complexity will be O(N<sup>2</sup>).
                            </p>
                        </div>
                    </div>

                    <div class="art req" title="Logarithms">
                        <div class="longt">
                            <h2 class="hlongt">Logarithm</h2>
                        </div>
                        <div class="description">
                            <img src="./img/log.png" alt="sort">
                        </div>
                    </div>

                </div>

                <div class="quiz" title="Pre-Test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Which of these best describes an array?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) A data structure that shows a hierarchical behavior</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) Container of objects of similar types</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Container of objects of mixed types</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) All of the mentioned</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>An array is a data structure, which can store a fixed-size collection of elements of
                                        the same data type.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question2">
                                <div class="art-body">
                                    <p>Q2. What is the time complexity of insertion at any point on an array?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) O(N)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) O(N^2)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) O(NLogN)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) None of these</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Taking a general
                                       example,inserting
                                       into the middle of an
                                       array, you have to
                                       shift all the
                                       elements after that
                                       element, so the
                                       complexity for
                                       insertion in that
                                       case is O(n).  Worst
                                       case would be when
                                       you have to insert at
                                       the starting of the
                                       array,you will need
                                       to move n elements
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question3">
                                <div class="art-body">
                                    <p>Q3. What does it mean when we say that an algorithm X is asymptotically more
                                        efficient than Y?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) X will always be a better choice for small inputs</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) X will always be a better choice for large inputs</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Y will always be a better choice for small inputs</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) X will always be a better choice for all inputs</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Performance could be similar for small inputs, but definitely better for larger
                                        inputs
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question4">
                                <div class="art-body">
                                    <p>Q4. int a = 0, b = 0; <br>
                                        for (i = 0; i &lt; N; i++) {<br>
                                        a = a + rand();<br>
                                        }<br>
                                        for (j = 0; j &lt; M; j++) {<br>
                                        b = b + rand();<br>
                                        }<br>
                                        What is the time and space complexity for the above code?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c1">
                                    <div class="art-body">
                                        <p>(A) O(N * M) time, O(1) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c2">
                                    <div class="art-body">
                                        <p>(B) O(N + M) time, O(N + M) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q2-c3">
                                    <div class="art-body">
                                        <p>(C) O(N + M) time, O(1) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q2-c4">
                                    <div class="art-body">
                                        <p>(D) O(N * M) time, O(N + M) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The first loop runs
                                       for O(n) time, second
                                       loop runs for O(m).
                                       Constant extra space
                                       is used for 2
                                       variables a and b,
                                       hence O(1) space.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="lu" title="Radix Sort">
                <div class="longt">
                    <h2 class="hlongt">The Radix Sort Algorithm</h2>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>

                    <div class="art req" title="Radixsort Concept and Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Radix Concept and Algorithm</h2>
                        </div>
                        <div class="description">
                            <p>radixsort video</p>
                        </div>
                    </div>

                    <div class="art txt" title="Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Learning Objectives of this Module :</h2>
                        </div>
                        <div class="art-body">
                            <p>In this module, we will : </p><br>
                            <ul>
                                <li>Learn the radix sort algorithm</li>
                                <li>See a demonstration of how the algorithm works</li>
                                <li>Practice the algorithm</li>
                                <li>Solve an exercise!</li>
                            </ul>
                        </div>
                    </div>
                </div>

                <div class="task" title="Radixsort : Concept">
                    <div class="longt">
                        <h2 class="hlongt">Radix Sort Concept</h2>
                    </div>

                    <div class="art req" title="Picture: Digits identification">
                        <div class="longt">
                            <h2 class="hlongt">Identifying the digits</h2>
                        </div>
                        <div class="description">
                            <img src="./img/digits.jpg" alt="digits">
                        </div>
                    </div>

                    <div class="art txt" title="Radixsort Concept">
                        <div class="longt">
                            <h2 class="hlongt">The Radixsort Concept</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                Radix sort is an integer sorting algorithm that sorts data with integer keys.<br />
                                It works by grouping the keys according to individual digits that share the same significant
                                position and value (place value), together into a container, which we usually call a
                                <strong>bucket.</strong><br />
                                It then sorts <th></th>e numbers in the order of placement in the buckets(least to highest).<br />
                                <strong> How does this work?</strong>
                                Lets take an example of this array : <strong>34, 123, 233, 239, 287, 319</strong> <br />
                                Radix sort uses the observation that in a sorted array of numbers, the numbers are :
                            </p>
                            <ul>
                                <li>Firstly, sorted according to the most significant digit. <br />
                                    <b>0</b>34, <b>1</b>23,<b>2</b>33, <b>2</b>39, <b>2</b>87, <b>3</b>19<br />
                                    The most significant digits(in bold) are in increasing order :
                                    <strong>0,1,2,2,2,3</strong>
                                </li>
                                <li>Among the ones with the same most significant digit(or higher place value digit),
                                    they are arranged in the order of their second most significant digit(or next higher
                                    place value) and so on.<br />
                                    Among 2<b>3</b>3, 2<b>3</b>9, 2<b>8</b>7 (same hundred's digit : most significant
                                    digit),<br />
                                    they are arranged in increasing order of the ten's digit (second most significant
                                    digit): <strong>3,3,8</strong>
                                </li>
                                <li>Continuing till the last digit, 23<b>3</b> and 23<b>9</b> are also arranged in the order
                                    of their unit's digit(same hundred's and ten's digit):<strong>3,9</strong>
                                </li>
                            </ul>
                            <p>This is the basic concept that radix sort uses along with a method to sort the numbers based
                                on <a href=""></a> particular place value (using buckets as told earlier in this section).
                            </p>
                        </div>
                    </div>

                    <div class="art txt" title="Digit extraction">
                        <div class="longt">
                            <h2 class="hlongt">Digit extraction</h2>
                        </div>
                        <div class="art-body">
                            <p> Have a look at the image above to understand what we mean by the "least significant digit"
                                and the "most significant digit".
                                To extract the digit at the i<sup>th</sup> position :
                            </p>
                            <ul>
                                <li> Divide the integer by 10<sup>(i-1)</sup> and take only the integral part. </li>
                                <li>Take the modulus of the resulting number with 10</li>
                                <li> Resulting number is your i<sup>th</sup> digit.</li>
                            </ul>
                            <p> <strong>For example:</strong><br>
                                Say 3<sup>rd</sup>rd least significant digit of <strong>26438</strong>, that is the the
                                hundred's position.<br>
                                <code>
                           First divide by 10<sup>3-1</sup> = 10<sup>2</sup> = 100. <br>
                           26438 / 100 = 264.<br>
                           Then take modulus with 10.<br>
                           264 % 10 = 4<br>
                                    <strong>4 is the third least significant digit.</strong>
                                </code>
                            </p>
                        </div>
                    </div>

                </div>

                <div class="task" title="Radixsort : Algorithm">
                    <div class="longt">
                        <h2 class="hlongt">Radix Sort Algorithm</h2>
                    </div>

                    <div class="art txt" title="Radixsort Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">The Radixsort Algorithm</h2>
                        </div>
                        <div class="art-body">
                            <ul>
                                <li>In radix sort, we first sort the elements based on last digit (least significant digit/
                                    units digit).</li>
                                <li>Then the resultant array is again sorted by the second last digit (tens digit).</li>
                                <li>This process is continued for all the digits in the same fashion until we finish doing the
                                    same for the most significant digit.</li>
                                <li>The resultant array obtained is a sorted array!</li>
                            </ul>
                        </div>
                    </div>

                    <div class="art req" title="Picture: Radixsort">
                        <div class="longt">
                            <h2 class="hlongt">Radix Sort steps</h2>
                        </div>
                        <div class="description">
                            <img src="./img/radix.jpg" alt="RS levels">
                        </div>
                    </div>

                    <div class="art txt" title="Radixsort Sorting using buckets">
                        <div class="longt">
                            <h2 class="hlongt">Sorting using buckets</h2>
                        </div>
                        <div class="art-body">
                            <p>The sorting is done using containers(which hold numbers with same place/significant digit under
                                consideration), as explained and shown using this example:<br />
                                Suppose we are sorting: 2<b>9</b>1,9<b>1</b>3,3<b>1</b>5,2<b>8</b>7,3<b>6</b>9 according to the
                                tens digit now(already sorted according to units)<br />
                                We iterate over all elements and place them in their respective buckets:
                            </p><br />
                            <p class="buckets"> bucket[0]-> empty<br />
                                bucket[1]-> 9<b>1</b>3, 3<b>1</b>5 <br />
                                bucket[2]-> empty<br />
                                bucket[3]-> empty<br />
                                bucket[4]-> empty<br />
                                bucket[5]-> empty<br />
                                bucket[6]-> 3<b>6</b>9 <br />
                                bucket[7]-> empty<br />
                                bucket[8]-> 2<b>8</b>7 <br />
                                bucket[9]-> 2<b>9</b>1 <br />
                            </p>
                            <p>Now we remove all the elements from the buckets( in order from 0->9 ) and put them back in the
                                array.<br />
                                Within the same bucket, the element that came in earlier, goes out first( FIFO principle: First
                                In First Out)<br />
                                Array obtained as a result will be: 913, 315, 369, 287, 291.<br />
                                <strong>Refer to this image below for a better understanding.The initial array is at the top in
                                blue and the final array in green, below the buckets.</strong>
                            </p>
                        </div>
                    </div>

                    <div class="art req" title="Picture: Sorting using buckets">
                        <div class="longt">
                            <h2 class="hlongt">Sorting using buckets</h2>
                        </div>
                        <div class="description">
                            <img src="./img/demo_radix.jpg" alt="Sorting using buckets">
                        </div>
                    </div>

                    <div class="art req" title="Radixsort Video">
                        <div class="longt">
                            <h2 class="hlongt">Radix Sort Video</h2>
                        </div>
                        <div class="description">
                            <p>Radix Sort animation</p>
                        </div>
                    </div>

                </div>

                <div class="task" title="Radixsort : Demo">
                    <div class="longt">
                        <h2 class="hlongt">Demonstration for Radix Sort Algorithm</h2>
                    </div>

                    <div class="art req" title="Radixsort Demo">
                        <div class="longt">
                            <h2 class="hlongt">Demo : Radix Sort</h2>
                        </div>
                        <div class="description">
                            <p>Representation of the whole process</p>
                        </div>
                    </div>

                </div>

                <div class="task" title="Radixsort : Practice">
                    <div class="longt">
                        <h2 class="hlongt">Practice for Radix Sort Algorithm</h2>
                    </div>

                    <div class="art req" title="Radixsort Practice">
                        <div class="longt">
                            <h2 class="hlongt">Practice : Radix Sort</h2>
                        </div>
                        <div class="description">
                            <p>Practice of the whole process</p>
                        </div>
                    </div>
                </div>
                <div class="task" title="Radixsort : Exercise">
                    <div class="longt">
                        <h2 class="hlongt">Exercise for Radix Sort Algorithm</h2>
                    </div>

                    <div class="art req" title="Radixsort Exercise">
                        <div class="longt">
                            <h2 class="hlongt">Exercise : Radix Sort</h2>
                        </div>
                        <div class="description">
                            <p>Exercise of the whole process</p>
                        </div>
                    </div>
                </div>

            </div>

            <div class="lu" title="Analysis">
                <div class="longt">
                    <h2 class="hlongt">Analysis of Radix Sort</h2>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>20 minutes</p>
                        </div>
                    </div>

                    <div class="art req" title="Analysis of Radixsort">
                        <div class="longt">
                            <h2 class="hlongt">Analysis of Radixsort</h2>
                        </div>
                        <div class="description">
                            <p> Time complexity is explained</p>
                        </div>
                    </div>

                    <div class="art txt" title="Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Learning Objectives of this Module</h2>
                        </div>
                        <div class="art-body">
                            In this module, we will look into :
                            <ul>
                                <li>
                                    <b>Time and Space Complexity</b> : We will learn about the running time of
                                    the sorting process.
                                </li>
                                <li>
                                    <b>Stable sort and Comparison sort</b> : We will learn about what stable
                                    and comparison sorts are. Then we will see how
                                    radix sort is a stable, non-comparison sort.
                                </li>
                                <li>
                                    <b>Applications</b> : We will compare radix sort with other
                                    sorting algorithms and see in which situations radix sort is the
                                    optimal approach to take.
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>

                <div class="task" title="Time and Space Complexity">
                    <div class="longt">
                        <h2 class="hlongt">Time and Space Complexity of Radix Sort</h2>
                    </div>

                    <div class="art txt" title="Time Complexity">
                        <div class="longt">
                            <h2 class="hlongt">Running Time of Radix Sort</h2>
                        </div>
                        <div class="art-body">
                            <p> The running time complexity of radix sort in <strong>O(nd)</strong> where :</p>
                            <ul>
                                <li><strong>n</strong> is the number of elements</li>
                                <li><strong>d</strong> is the maximum number of digits in any element of the array</li>
                            </ul>
                            <p>Each step of the algorithm (when we are putting the elements in buckets according to say the
                                m'th digit)
                                requires O(n) time as we iterate over all the elements of the array.</p>
                            <p>Now there will be d steps in order to sort the whole array.</p>
                            <p>Hence the time complexity becomes O(nd)</p>
                        </div>
                    </div>

                    <div class="art req" title="Picture: Time Complexity">
                        <div class="longt">
                            <h2 class="hlongt">Explaining time complexity of Radix sort</h2>
                        </div>
                        <div class="description">
                            <img src="./img/radix_complexity.jpg" alt="Radix time complexity">

                        </div>
                    </div>

                    <div class="art txt" title="Space Complexity">
                        <div class="longt">
                            <h2 class="hlongt">Space Complexity of Radix Sort</h2>
                        </div>
                        <div class="art-body">
                            <p>Space Complexity for Radix sort is <strong>O(n+b)</strong> where :</p>
                            <ul>
                                <li><strong>n</strong> is the number of elements</li>
                                <li><strong>b</strong> is the base of the number representation being used which is equal to
                                    the number of buckets required</li>
                            </ul>
                            <p>A space of O(n) is required to store the elements and O(b) is for the buckets used while
                                sorting. Hence complexity becomes O(n+b)</p>
                        </div>
                    </div>
                </div>

                <div class="task" title="Stable and Comparison sort">

                    <div class="longt">
                        <h2 class="hlongt">Stable sort and Comparison sort</h2>
                    </div>

                    <div class="art txt" title="Comparison Sort">
                        <div class="longt">
                            <h2 class="hlongt">What is a Comparison Sort Algorithm?</h2>
                        </div>
                        <div class="art-body">
                            <p>A Comparison Sort is a sorting algorithm where the final order is
                                determined only by comparisons between the input elements.
                            </p>
                            <p>
                                In Radix Sort, the values of the elements are never compared. The elements are just placed
                                into buckets according to the digit under consideration.
                            </p>
                            <p>Hence, Radix Sort is not a comparison based sort.</p>
                        </div>
                    </div>

                    <div class="art txt" title="Stable Sort">
                        <div class="longt">
                            <h2 class="hlongt">What is a Stable Sort Algorithm?</h2>
                        </div>
                        <div class="art-body">
                            <p>A sorting algorithm is said
                               to be <b>stable</b> if two
                               objects with equal keys
                               appear in the same order in
                               the sorted output as they
                               appear in the input unsorted
                               array. For example, look at
                               the picture below. The
                               unsorted array has two
                               elements with value 23. Note
                               the order of both these
                               elements in the stable and
                               unstable sorted arrays.
                            </p>
                        </div>
                    </div>

                    <div class="art req" title="Stable and Unstable sort">
                        <div class="longt">
                            <h2 class="hlongt">Stable and Unstable sort</h2>
                        </div>
                        <div class="description"><br><br>
                            <img src="./img/stable.png" alt="stable sort">
                        </div>
                    </div>

                    <div class="art txt" title="Stability of Radixsort">
                        <div class="longt">
                            <h2 class="hlongt">Is Radix Sort stable?</h2>
                        </div>
                        <div class="art-body">
                            <p>Yes, radix sort is a stable sorting algorithm. Look at the picture below and keep an eye out
                               for the ordering of <b>75</b> and <b>75*</b>. Note how the original order of these elements
                               is retained throughout the sorting process. The relative positioning of 75 and 75* does not
                               change in the sorted output.
                            </p>
                        </div>
                    </div>

                    <div class="art req" title="Picture: Stable Radixsort">
                        <div class="longt">
                            <h2 class="hlongt">Stability of Radixsort</h2>
                        </div>
                        <div class="art-body">
                            <img src="./img/stable_radix.jpg" alt="Stable radixsort">
                        </div>
                    </div>
                </div>

                <div class="task" title="Comparison with other algorithms">
                    <div class="longt">
                        <h2 class="hlongt">Comparison with other algorithms</h2>
                    </div>

                    <div class="art req" title="Picture: Comparison of algorithms">
                        <div class="longt">
                            <h2 class="hlongt">Comparison of algorithms</h2>
                        </div>
                        <div class="art-body">
                            <img src="./img/comparison.png" alt="comparison">
                        </div>
                    </div>

                    <div class="art txt" title="Comparison Table">
                        <div class="longt">
                            <h2 class="hlongt">Comparison with other sorting algorithms</h2>
                        </div>
                        <div class="art-body">
                            <table>
                                <tbody>
                                    <tr>
                                        <th style="text-align:center" colspan="1">Algorithm</th>
                                        <th style="text-align:center" colspan="3">Time</th>
                                        <th style="text-align:center" colspan="2">Features</th>
                                    </tr>
                                    <tr id="headings">
                                        <td><strong>Sort</strong></td>
                                        <td><strong>Average</strong></td>
                                        <td><strong>Best</strong></td>
                                        <td><strong>Worst</strong></td>
                                        <td><strong>Space</strong></td>
                                        <td><strong>Stability</strong></td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black"
                                               href="//www.cprogramming.com/tutorial/computersciencetheory/sorting1.html">Radix
                                            sort</a></td>
                                        <td>O(nk)</td>
                                        <td>O(nk)</td>
                                        <td>O(nk)</td>
                                        <td>O(n+b)</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black"
                                               href="//www.cprogramming.com/tutorial/computersciencetheory/sorting1.html">Bubble
                                            sort</a></td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>Constant</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black"
                                               href="//www.cprogramming.com/tutorial/computersciencetheory/sorting1.html">Modified
                                            Bubble sort</a></td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>Constant</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black"
                                               href="//www.cprogramming.com/tutorial/computersciencetheory/sorting2.html">Selection
                                            Sort</a></td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>Constant</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black"
                                               href="//www.cprogramming.com/tutorial/computersciencetheory/sorting2.html">Insertion
                                            Sort</a></td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>O(n)</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>Constant</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black"
                                               href="//www.cprogramming.com/tutorial/computersciencetheory/heapsort.html">Heap
                                            Sort</a></td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n*log(n))</td>
                                        <td>Constant</td>
                                        <td>Unstable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black"
                                               href="//www.cprogramming.com/tutorial/computersciencetheory/mergesort.html">Merge
                                            Sort</a></td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n*log(n))</td>
                                        <td>Depends</td>
                                        <td>Stable</td>
                                    </tr>
                                    <tr class="tablerows">
                                        <td><a style="text-decoration:none;color:black"
                                               href="//www.cprogramming.com/tutorial/computersciencetheory/quicksort.html">Quicksort</a>
                                        </td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n*log(n))</td>
                                        <td>O(n<sup>2</sup>)</td>
                                        <td>Constant</td>
                                        <td>Stable</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>

                    <div class="art txt" title="Final Verdict">
                        <div class="longt">
                            <h2 class="hlongt">When is Radix sort actually used?</h2>
                        </div>
                        <div class="art-body">
                            <p> As we have seen, radix sort seems to have better time complexity than other sorting
                                algorithms. Pertinent question is, why is it not as popular as the other algorithms? Here's
                                why:</p>
                            <ul>
                                <li>
                                    Radix sort only applies to integers, fixed size strings, floating points and to "less
                                    than", "greater than" or "lexicographic order" comparisons whereas comparison sorts can
                                    accommodate different orders.
                                </li>
                                <li>
                                    k can be greater than log N, and when this happens comparison sorts become faster.
                                </li>
                                <li>
                                    Popularly used comparison based sorting algorithms like quick sort can be done in place whereas
                                    radix sort is less efficient in terms of space complexity.
                                </li>
                            </ul>
                        </div>
                    </div>

                </div>

                <div class="quiz" title="Analysis Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Revision Quiz for Analysis</h2>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. What is the complexity of Radix sort?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) Best case O(nk)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) Best case O(n<sup>2</sup>)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Worst case O(n<sup>2</sup>)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) Average case O(nk)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(E) A and D</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Best case is O(nk) and average case is also O(nk). Procedure remains the same and the
                                        algorithm iterates over all elements regardless.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q2. Given N and b, what is k ?(N is the maximum value element in the array, b is the
                                        base of the number representation, k is the number of buckets you will need)</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) k = ceil(log<sub>b</sub>N)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) k = floor(log<sub>b</sub>N)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Depends</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) Can't say</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Take b to be the base of your representation. Then the number of digits in the
                                        largest number(k) is equal to taking the upper bound of log<sub>b</sub>N
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q3. What kind of sorting algorithm is radix sort?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) Comparison based, stable)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) Not comparison based, unstable</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Not comparison based, stable</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) None of the above</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Radix sort is not a comparison based algorithm and it is stable.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="lu" title="Post Test">
                <div class="longt">
                    <h2 class="hlongt">Post Test of the Experiment</h2>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>

                    <div class="art txt" title="Objectives">
                        <div class="longt">
                            <h2 class="hlongt">Instructions for Quiz</h2>
                        </div>
                        <div class="art-body">
                            <p>Post Test includes questions on concepts from the entire experiment. Read
                                the questions in the quiz section
                                and select the correct option
                                from the ones provided. Please
                                note that some questions may have
                                more than one correct response.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="quiz" title="Post Test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Quiz Time!</h2>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q1. Given an array where numbers are in range from 1 to n<sup>6</sup>, which sorting
                                       algorithm can be used to sort these numbers in linear time?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A) Not possible to sort in linear time</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B) Radix Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Bucket Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) Quick Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Radix Sort can be used to sort such a case in linear time as explained in the
                                        analysis section.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q2.If we use Radix Sort to sort n integers in the range
                                        (n<sup>k/2</sup>,n<sup>k</sup>, for some k>0 which is independent of n, the time
                                        taken
                                        would be?
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A)Theta(n)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B)Theta(k.n)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) Theta(n.logn)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) Theta(n<sup>2</sup>)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p> Radix sort time complexity = O(wn), for n keys of word size = w<br />
                                        => w = log(n^k)<br />
                                        O(wn) = O(k. logn . n)<br />
                                        => k.O(n.logn)<br />
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q3.If there are n integers to sort, each integer has d digits, and each digit is in
                                        the set {1, 2, ..., k}, radix sort can
                                        sort the numbers in:
                                    </p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A)O(k (n + d))</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B)O(d (n + k))</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C) O((n + k) lg d)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D) O((n + d) lg k)</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>If there are n integers to sort, each integer has d digits,
                                        and each digit is in the set {1, 2, ..., k},
                                        radix sort can sort the numbers in O(d (n + k))
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="question1">
                                <div class="art-body">
                                    <p>Q4.Radix Sort uses which of the following as a subroutine?</p>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c1">
                                    <div class="art-body">
                                        <p>(A)Merge Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c2">
                                    <div class="art-body">
                                        <p>(B)Quick Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="q1-c3">
                                    <div class="art-body">
                                        <p>(C)Counting Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="q1-c4">
                                    <div class="art-body">
                                        <p>(D)Heap Sort</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The idea of putting elements into buckets/containers to (which themselves are
                                       arranged in a particular order) to sort the elements; is the idea used in countsort.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>

               <!--  <div class="lu" title="Feedback">
                    <div class="longt">
                        <h2 class="hlongt">Feedback of the Experiment</h2>
                    </div>

                    <div class="preamble">
                        <div class="art txt" title="Feedback Form">
                            <div class="longt">
                                <h2 class="hlongt">Feedback Form of the Experiment</h2>
                            </div>
                            <div class="art-body">
                                <p>The experiment ends here,thanks
                                   for participating! Please fill
                                   up the form.
                                </p>
                            </div>
                        </div>
                    </div>
                </div> -->

                <div class="lu" title="Further Readings/References">
                    <div class="longt">
                        <h2 class="hlongt">Further Readings and References of the Experiment</h2>
                    </div>

                    <div class="preamble">

                        <div class="art txt" title="Explore">
                            <div class="longt">
                                <h2 class="hlongt">Explore More About Radix</h2>
                            </div>
                            <div class="art-body">
                                <p>You can explore more about
                                    Radix Experiment through
                                    following resources:
                                </p>
                                <br />
                                <b>Some more concepts :</b>
                                <ul>
                                    <li>
                                        <a
                                            href="https://www.hackerearth.com/practice/algorithms/sorting/radix-sort/tutorial/">
                                            Perform RadixSort using CountSort
                                        </a>
                                    </li>
                                    <li>
                                        <a
                                            href="https://www.codingeek.com/algorithms/radix-sort-explanation-pseudocode-and-implementation/">
                                            Radix Sort : important features and implementation
                                        </a>
                                    </li>
                                </ul>

                                <b>Quizzes :</b>
                                <ul>
                                    <li>
                                        <a href="https://www.geeksforgeeks.org/algorithms-gq/searching-and-sorting-gq/">
                                            Combined Quiz for Sorting Algorithms
                                        </a>
                                    </li>
                                    <li>
                                        <a href="https://www.geeksforgeeks.org/quiz-radixsort-gq/">
                                            Online Quiz on Radix Sort
                                        </a>
                                    </li>
                                    <li>
                                        <a href="https://www.youtube.com/watch?v=xuU-DS_5Z4g">
                                            Video animation for Radixsort
                                        </a>
                                    </li>
                                </ul>

                                <b>References and Credits :</b>
                                <ul>
                                    <li><a href="https://www.youtube.com/watch?v=nu4gDuFabIM">Radixsort Explanation</a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <script src="./js/loader.js"></script>
    </body>
</html>
